﻿<?php

///////////////////////////////////////////////////
// Coded by 20Script.ir //
// Copyright (C) 2013 Mohammad Rahmani           //
///////////////////////////////////////////////////

include_once 'includes/server.php';
global $db, $msg, $mailsender;

function getValidation($id, $ts, $email, $username) {
    return base64_encode(md5($id . md5($ts) . 'APADANADEV' . strrev($email) . $username));
}

//if this script is included by another script, don't continue the code
if (strpos($_SERVER['PHP_SELF'], 'account_servant.php') === false)
    return;

//initialize
$msg = array();

if (isset($_GET['activate'])) {
    //Request: Activate user account
    //return database user obj
    $userobj = $db->user;

    //parse request
    $id = $_GET['id'];
    $ts = base64_decode($_GET['ts']);
    $validation = $_GET['validation'];
    //check id in the database
    $data = $db->get_as_array($userobj->selectByID($id));
    if (count($data) != 1) {
        $msg['icon'] = 2;
        $msg['shortdesc'] = 'کاربر موجود نیست.';
    } else {
        //validate request
        $email = $data[0]['email'];
        $username = $data[0]['username'];
        $active = $data[0]['active'];
        if ($validation != getValidation($id, $ts, $email, $username))
            die('Invalid Request.');
        //check if the user is already valid
        if ($active) {
            //user is already active!
            $msg['icon'] = 0;
            $msg['shortdesc'] = 'حساب کاربری شما در حال حاضر فعال می باشد!';
            $msg['buttons'][] = array('title' => 'صفحه اصلی', 'link' => 'index.php');
        } else {
            //validate time stamp
            if (date('U') - $ts > reg_email_confirmation_expiration_time) {
                //expired link
                $msg['icon'] = 2;
                $msg['shortdesc'] = 'لینک منقضی شده است.';
                $msg['desc'] = 'لینک فعال سازی شما به دلیل دیرکرد شما منقضی شده است. به صفحه اصلی بروید و مجدداً ایمیل فعال سازی درخواست کنید.';
                $msg['buttons'][] = array('title' => 'صفحه اصلی', 'link' => 'index.php');
            } else {
                //valid request!
                $data = array();
                $data['active'] = true;
                $userobj->updateByID($id, $data);
                $userobj->sendActivatedEmail($id);

                //display success message
                $msg['icon'] = 1;
                $msg['shortdesc'] = 'حساب کاربری شما فعال شد!<script type="text/javascript">setTimeout(function(){window.location.href=\'index.php\';},5000);</script>';
                $msg['desc'] = 'حساب کاربری شما فعال شد و از الان  می توانید از امکانات سایت استفاده کنید!';
                $msg['buttons'][] = array('title' => 'صفحه اصلی', 'link' => 'index.php');
            }
        }
    }
} else if (isset($_GET['reset'])) {
    //Request: Reset Password
    $id = mysql_escape_string($_GET['id']);
    $type = $_GET['t'];
    $ts = base64_decode($_GET['ts']);
    $validation = $_GET['validation'];
    $obj = $type == 'e' ? $db->employee : $db->employer;
    $rec = $db->get_as_array($obj->query("select `id`,`username`,`email` from `$$$`.`###` where `id`='$id'"));
    if (count($rec) == 1) {
        //user found
        //get info
        $rec = $rec[0];
        $id = $rec['id'];
        $username = $rec['username'];
        $email = $rec['email'];
        //validate request
        if (getValidation($id, $ts, $email, $username) == $validation) {
            //validation is ok
            //check time stamp
            if (date('U') - $ts < reset_confirmation_expiration_time) {
                //everything is ok!
                //choose a new password
                $newpw = rand(100000, 999999);
                $rec = array();
                $rec['password'] = hash_password($newpw);
                $obj->updateByID($id, $rec);
                if (mysql_affected_rows() != 0) {
                    //reset ok
                    $body = 'اطلاعات حساب کاربري شما اکنون به شرح زير است:<br /><br />نام کاربري شما: ' . $username . '<br />کلمه عبور شما: ' . $newpw . '<br /><br />موفق و پيروز باشيد';
                    $mailsender->sendMailGenerate($email, 'اطلاعات ورود به حساب کاربری', $body, email_noreply);
                    $msg['icon'] = 1;
                    $msg['shortdesc'] = 'پسورد شما تغییر یافت!';
                    $msg['desc'] = 'کلمه عبور شما تغییر یافت و به همراه نام کاربری به ایمیل شما (<b>' . $email . '</b>) ارسال شد!';
                } else {
                    //reset failed
                    $msg['icon'] = 2;
                    $msg['shortdesc'] = 'به دلیل مشکلی در دیتابیس درانجام درخواست شما مقدور نشد.';
                }
            } else {
                //confirmation is expired
                $msg['icon'] = 2;
                $msg['shortdesc'] = 'درخواست منقضی شده.';
                $msg['desc'] = 'مهلت شما برای یادآوری حساب کاربری منقضی شده است، لطفاً مجدداً درخواست دهید.';
            }
        } else {
            //invalid validation
            $msg['icon'] = 2;
            $msg['shortdesc'] = 'درخواست غیر مجاز.';
        }
    } else {
        //user not found
        $msg['icon'] = 2;
        $msg['shortdesc'] = 'کاربر پیدا نشد.';
    }
} else if (isset($_GET['logout'])) {
    //Request: Logout
    global $login;
    $login->logout();
    if (isset($_GET['ref']))
        header('Location: http://' . address);
} else
    die('Request base is invalid.');
$_GET['module'] = 'msg';
include 'index.php';
//$db->disconnect();
?>
