﻿<?php

///////////////////////////////////////////////////
//  scriptcamp.ir              //
///////////////////////////////////////////////////

abstract class captcha {

    protected abstract function random_key_start();

    protected abstract function random_key_end();

    public abstract function getCaptchaAnswer($key);

    public abstract function getCaptchaQuestion($key);

    public abstract function isCaptchaValid($key, $uservalue);

    public function getRandomKey() {
        return rand($this->random_key_start(), $this->random_key_end());
    }

    public function updateSessionKey($rndkey = 0) {
        if ($rndkey == 0)
            $rndkey = $this->getRandomKey();
        $_SESSION['captcha_key'] = $rndkey;
    }

    public function getSessionKey() {
        $r = isset($_SESSION['captcha_key']) ? $_SESSION['captcha_key'] : 0;
        if ($r != 0 && $r >= $this->random_key_start() && $r <= $this->random_key_end())
            return $r;
        else
            return 0;
    }

}

class captcha_qa extends captcha {

    protected $questions = array(
        array('q' => 'پایتخت ایران؟', 'a' => 'تهران'),
        array('q' => '2 به علاوه 3؟', 'a' => '5'),
        array('q' => '9 * 6 = ?', 'a' => '54'),
        array('q' => '2 * 3 = ?', 'a' => '6'),
        array('q' => '7 * 6 = ?', 'a' => '42'),
        array('q' => '8 + 9 = ?', 'a' => '17'),
        array('q' => 'در کادر بنویسید ایران.', 'a' => 'ایران'),
        array('q' => '5 ضربدر 3.', 'a' => '15'),
        array('q' => 'کلمه ی "بازدید" چند حرف دارد؟', 'a' => '6'),
        array('q' => 'شهری که به آن نصف جهان میگویند؟', 'a' => 'اصفهان')
        
    );

    private function getindex($key) {
        return (ceil($key * 1.5)) % count($this->questions);
    }

    protected function random_key_start() {
        return 10000;
    }

    protected function random_key_end() {
        return 100000;
    }

    public function getCaptchaQuestion($key = '') {
        if ($key == '')
            return $this->getCaptchaQuestion($this->getSessionKey());
        return $this->questions[$this->getindex($key)]['q'];
    }

    public function getCaptchaAnswer($key = '') {
        if ($key == '')
            return $this->getCaptchaAnswer($this->getSessionKey());
        return $this->questions[$this->getindex($key)]['a'];
    }

    public function isCaptchaValid($key, $uservalue) {
        return trim($this->getCaptchaAnswer($key)) == trim($uservalue);
    }

}

?>
