<?php
if (!isset($loggedIn) || !$loggedIn) {
    echo '<h1>برای دسترسی به این صفحه باید ابتدا به سایت وارد شوید.</h1>';
    return;
}

function newItem($type, $name, $text, $value, $arg4 = '') {
    switch ($type) {
        case 'text':
        case 'password':
            echo '<tr><td>' . $text . '</td><td><input type="' . $type . '" name="' . $name . '" value="' . $value . '" /></td></tr>';
            break;
        case 'checkbox':
            echo '<tr><td>' . $text . '</td><td><input type="' . $type . '" name="' . $name . '" value="1" id="' . $name . '"' . ($value ? ' checked' : '') . ' /><label for="' . $name . '"> ' . $arg4 . '</label></td></tr>';
            break;
        case 'select':
            echo '<tr><td>' . $text . '</td><td><select name="' . $name . '">';
            $i = 0;
            foreach ($arg4 as $r)
                echo '<option value="' . $i . '"' . ($i++ == $value ? ' selected="selected"' : '') . '>' . $r . '</option>';
            echo '</select></td></tr>';
            break;
        default:
            die($type . ' unsupported.');
    }
}

$msg = '';

if (isset($_POST['firstname'])) {
    //register new user
    $id = $loginInfo['id'];
    $msg = '';
    $pw_change = $_POST['newpw'] != '' && $_POST['oldpw'] != '';
    if ($pw_change) {
        //change password is requested
        if (strlen($_POST['newpw']) < pw_min_len)
            $msg = '<div class="msg error">کلمه عبور را صحیح وارد کنید. (حداقل ' . pw_min_len . ' حرف)</div>';
        else if ($_POST['newpw'] != $_POST['renewpw'])
            $msg = '<div class="msg error">کلمه عبور با تکرار آن مطابقت ندارد.</div>';
        else if (hash1($_POST['oldpw']) != Login::getCookiePassword())
            $msg = '<div class="msg error">کلمه عبور قبلی اشتباه است.</div>';
    }
    if ($msg != '')
        $msg = $msg;
    else if (!isEmailValid($_POST['email']))
        $msg = '<div class="msg error">ایمیل صحیح نیست.</div>';
//    else if (!isWebsiteValid($_POST['website']))
//        $msg = '<div class="msg error">آدرس وب سایت را صحیح وارد کنید.</div>';
    else if (strtolower($_POST['email']) != strtolower($loginInfo['email']) && $db->user->emailExists($_POST['email']))
        $msg = '<div class="msg error">ایمیل وارد شده قبلاً ثبت شده است.</div>';
    else {
        //do register
        if ($pw_change) {
            $r['password'] = hash_password($_POST['newpw']);
            Login::setCookies($loginInfo['un'], hash1($_POST['newpw']));
        }
        $r['email'] = $_POST['email'];
        $r['firstname'] = $_POST['firstname'];
        $r['lastname'] = $_POST['lastname'];
        $r['tel'] = $_POST['tel'];
        $r['website'] = parseWebsite($_POST['website']);
        $r['bank'] = $_POST['bank'];
        $r['cardno'] = $_POST['cardno'];
        $db->user->updateById($id, $r);
        echo '<h1>اطلاعات جدید ذخیره شد.</h1><a href="Settings">بازگشت به تنظیمات</a>';
        return;
    }
}
echo $msg;
?>
<form action="" method="POST">
<fieldset>
<br>
    <h1>مشخصات فردی</h1>
    <table class="login-panel">
        <?php
        newItem('text', 'firstname', 'نام', $loginInfo['firstname']);
        newItem('text', 'lastname', 'نام خانوادگی', $loginInfo['lastname']);
        newItem('text', 'email', 'ایمیل *', $loginInfo['email']);
        newItem('text', 'tel', 'شماره همراه', $loginInfo['tel']);
        newItem('text', 'website', 'وب سایت', $loginInfo['website']);
        ?>
    </table>
<br></fieldset>
<br>
<fieldset><br><h1>اطلاعات بانکی</h1>
    <table class="login-panel">
        <?php
        newItem('select', 'bank', 'بانک', $loginInfo['bank'], $banks);
        newItem('text', 'cardno', 'شماره کارت', $loginInfo['cardno']);
        ?>
    <p>درخواست واریز تا حداکثر 24 ساعت پس از ثبت درخواست به حساب شما واریز می گردد .</p>
    </table>
<br></fieldset>
<br>
<fieldset><br><br><h1>تغییر کلمه عبور</h1>
    <p><i>تنها در صورتی که می خواهید کلمه عبور خود را تغییر دهید، اطلاعات زیر را کامل کنید.</i></p>
    <table class="login-panel">
        <?php
        newItem('password', 'oldpw', 'کلمه عبور قبلی', '');
        newItem('password', 'newpw', 'کلمه عبور جدید', '');
        newItem('password', 'renewpw', 'تکرار کلمه عبور جدید', '');
        ?>
    </table>
<br></fieldset>
    <div style="text-align: center;padding-top:30px;padding-bottom:20px;">
        <input type="submit" value="ذخیره" />
        <input type="reset" value="از نو" />
    </div>
</form>